<template>
  <div class="applications">
    <div class="applications-title">
      <b>Дархостҳо</b> барои санҷиш ва тасдиқ
    </div>

    <div class="applications-exercises">
      <div class="applications-subtitle">Супоришҳои нав:</div>
      <accordion
        v-if="exercises.length > 0"
        v-for="(exercise, id) in exercises"
        :key="exercise._id"
      >
        <template v-slot:title> {{ id + 1 }}. {{ exercise.title }} </template>
        <template v-slot:content>
          <ul>
            <li>
              Ному насаби омӯзгор: <b> {{ exercise.teacher_name }}</b>
            </li>
            <li>
              Ҷои кор: <b> {{ exercise.teacher_workplace }}</b>
            </li>
            <li>
              Телефон: <b> {{ exercise.teacher_phone }}</b>
            </li>
          </ul>
          <button @click="giveAccessExercise(exercise.title, exercise._id)">
            Иҷозат додан
          </button>
          <nuxt-link
            :to="`${exercise.url}?access=${exercise.access}`"
            target="_blank"
            @click.stop=""
          >
            <button type="button" @click.stop="">
              Аз назар гузаронидани супориш
            </button>
          </nuxt-link>
        </template>
      </accordion>
    </div>

    <div class="applications-teachers">
      <div class="applications-subtitle">
        Истифодабарандагони нав барои вазифаи <b>омӯзгор</b>:
      </div>
      <accordion v-for="teacher in teachers" :key="teacher._id">
        <template v-slot:title>
          <span>{{ teacher.name }}</span>
        </template>
        <template v-slot:content>
          <ul>
            <li>
              Телефон: <b> {{ teacher.phone }}</b>
            </li>
            <li>
              Ноҳия: <b>{{ teacher.region }} </b>
            </li>
            <li>
              Ихтисос: <b>{{ teacher.specialization }} </b>
            </li>
            <li>
              Ҷои кор: <b>{{ teacher.workplace }} </b>
            </li>
            <li>
              Маълумот: <b>{{ teacher.education }} </b>
            </li>
            <li>
              Санаи таваллуд: <b>{{ teacher.birthday }}</b>
            </li>
          </ul>
          <button @click="giveAccessTeacher(teacher.name, teacher._id)">
            Иҷозат додан
          </button>
        </template>
      </accordion>
    </div>
    <Confirm />
  </div>
</template>

<script>
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      exercises: [],
      teachers: [],
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getApplications();
  },
  methods: {
    giveAccessExercise(name, id) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Шумо мутмаин ҳастед, ки мехоҳед дастрасиро ба супориши "${name}" ба система иҷозат диҳед ?`,
        button: {
          yes: "Иҷозат додан",
          no: "Баргаштан",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/profile/giveAccessExercise", { id })
              .then(() => {
                this.exercises = this.exercises.filter((t) => t._id !== id);
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },
    giveAccessTeacher(name, id) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Оё мутмаин ҳастед, ки мехоҳед дастрасиро ба система барои "${name}" иҷозат диҳед?`,
        button: {
          yes: "Иҷозат додан",
          no: "Баргаштан",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/profile/giveAccessTeacher", { id })
              .then(() => {
                this.teachers = this.teachers.filter((t) => t._id !== id);
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },
    getApplications() {
      this.$axios
        .$get("/profile/getApplications")
        .then(({ teachers, exercises }) => {
          this.teachers = teachers;
          this.exercises = exercises;
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.applications {
  min-height: 70vh;
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  width: 100%;
  @include less-than(tablet) {
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    b {
    }
  }

  &-subtitle {
    line-height: 1.3;
    font-size: 20px;

    b {
    }
  }

  &-teachers,
  &-exercises {
    max-height: 400px;
    overflow: auto;
    padding: 10px;
    border: 1px solid #e1e1e6;
    margin-top: 10px;

    ul {
      margin: 0;
      margin-bottom: 20px;
      padding: 0;
    }

    li {
      list-style: none;
      margin: 0;
      padding: 0;
      margin-bottom: 10px;
      b {
        margin-left: 10px;
      }
    }
    button {
      background: none;
      border: 1px solid #ccc;
      padding: 10px;
      transition: all ease 0.3s;
      margin-bottom: 20px;
      &:hover {
        border-color: #0c63e4;
        color: #0c63e4;
      }
    }
  }
}
</style>
